shithub: puzzles

Download patch

ref: 894921015dde693697647b98b0c41467dcc91c08
parent: f49c7f530cfc5f0cc988be265e243e074279b761
author: Simon Tatham <anakin@pobox.com>
date: Mon May 18 12:17:49 EDT 2015

Move the benchmarking logic out into a script.

It's a pain having it in a rule in Makefile.gtk, which isn't even the
recommended makefile these days - it can't be re-run conveniently, and
there's no way to parametrise it. Now it can be run no matter which
makefile you're using, and it lets you narrow down to a subset of
games (though not presets). Other options could easily be added.

--- a/Recipe
+++ b/Recipe
@@ -142,11 +142,7 @@
 benchmark.html: benchmark.txt benchmark.pl
 	./benchmark.pl benchmark.txt > $@
 
-benchmark.txt: $(GAMES)
-	for i in $(GAMES); do \
-		for params in $$(env -i ./$(BINPREFIX)$$i --list-presets | cut -f1 -d' '); do \
-			env -i ./$(BINPREFIX)$$i --test-solve --time-generation --generate 100 $$params \
-			|| exit 1; \
-		done; \
-	done > $@
+benchmark.txt: benchmark.sh $(GAMES)
+	./benchmark.sh > $@
+
 !end
--- a/benchmark.pl
+++ b/benchmark.pl
@@ -1,5 +1,7 @@
 #!/usr/bin/perl
 
+# Process the raw output from benchmark.sh into Javascript-ified HTML.
+
 use strict;
 use warnings;
 
--- /dev/null
+++ b/benchmark.sh
@@ -1,0 +1,27 @@
+#!/bin/sh
+
+# Run every puzzle in benchmarking mode, and generate a file of raw
+# data that benchmark.pl will format into a web page.
+
+# If any arguments are provided, use those as the list of games to
+# benchmark. Otherwise, read the full list from gamedesc.txt.
+if test $# = 0; then
+    set -- $(cut -f1 -d: < gamedesc.txt)
+fi
+
+failures=false
+
+for game in "$@"; do
+    # Use 'env -i' to suppress any environment variables that might
+    # change the preset list for a puzzle (e.g. user-defined extras)
+    presets=$(env -i ./$game --list-presets | cut -f1 -d' ')
+    for preset in $presets; do
+	if ! env -i ./$game --test-solve --time-generation \
+                            --generate 100 $preset;
+        then
+            echo "${game} ${preset} failed to generate" >&2
+        fi
+    done
+done
+
+if $failures; then exit 1; fi